package nwweb

import (
	"fmt"
	"git.nwestland.com/tools/nwjson"
	"strconv"
)

const (
	GET     = "GET"
	HEAD    = "HEAD"
	POST    = "POST"
	PUT     = "PUT"
	PATCH   = "PATCH"
	DELETE  = "DELETE"
	CONNECT = "CONNECT"
	OPTIONS = "OPTIONS"
	TRACE   = "TRACE"
)

const (
	TLS10 = 0x0301
	TLS11 = 0x0302
	TLS12 = 0x0303
	TLS13 = 0x0304
	SSL30 = 0x0300
)

func stringToBytes(stringVal string) []byte {
	return []byte(stringVal)
}

func stringToInt(stringVal string) (val int) {
	val, _ = strconv.Atoi(stringVal)
	return
}

func stringToBool(stringVal string) (val bool) {
	val, _ = strconv.ParseBool(stringVal)
	return
}

func stringToFloat32(stringVal string) float32 {
	value, _ := strconv.ParseFloat(stringVal, 32)
	return float32(value)
}

func stringToFloat64(stringVal string) (val float64) {
	val, _ = strconv.ParseFloat(stringVal, 64)
	return
}

func stringToObject(stringVal string) nwjson.Object {
	return nwjson.ObjectFromString(stringVal)
}

func stringToArray(stringVal string) nwjson.Array {
	return nwjson.ArrayFromString(stringVal)
}

func anyToString(value any) string {
	switch value.(type) {
	case nwjson.Object:
		return value.(nwjson.Object).ToString()
	case nwjson.Array:
		return value.(nwjson.Array).ToString()
	default:
		return fmt.Sprintf("%v", value)
	}
}
